diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/dsdv/bindings/modulegen__gcc_LP64.py ns-3.36/src/dsdv/bindings/modulegen__gcc_LP64.py
--- ns-3.35/src/dsdv/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/dsdv/bindings/modulegen__gcc_LP64.py	2022-04-30 18:23:57.818733500 -0700
@@ -6970,10 +6984,11 @@
                    'uint32_t', 
                    [param('uint8_t *', 'buffer'), param('uint32_t', 'maxSize')], 
                    is_const=True)
-    ## packet.h (module 'network'): void ns3::Packet::SetNixVector(ns3::Ptr<ns3::NixVector> nixVector) [member function]
+    ## packet.h (module 'network'): void ns3::Packet::SetNixVector(ns3::Ptr<ns3::NixVector> nixVector) const [member function]
     cls.add_method('SetNixVector', 
                    'void', 
-                   [param('ns3::Ptr< ns3::NixVector >', 'nixVector')])
+                   [param('ns3::Ptr< ns3::NixVector >', 'nixVector')], 
+                   is_const=True)
     ## packet.h (module 'network'): std::string ns3::Packet::ToString() const [member function]
     cls.add_method('ToString', 
                    'std::string', 
@@ -7890,11 +7905,11 @@
     cls.add_method('GetEventId', 
                    'ns3::EventId', 
                    [param('ns3::Ipv4Address', 'address')])
-    ## dsdv-rtable.h (module 'dsdv'): void ns3::dsdv::RoutingTable::GetListOfAllRoutes(std::map<ns3::Ipv4Address, ns3::dsdv::RoutingTableEntry, std::less<ns3::Ipv4Address>, std::allocator<std::pair<const ns3::Ipv4Address, ns3::dsdv::RoutingTableEntry> > > & allRoutes) [member function]
+    ## dsdv-rtable.h (module 'dsdv'): void ns3::dsdv::RoutingTable::GetListOfAllRoutes(std::map<ns3::Ipv4Address, ns3::dsdv::RoutingTableEntry, std::less<ns3::Ipv4Address>, std::allocator<std::pair<const ns3::Ipv4Address, ns3::dsdv::RoutingTableEntry>>> & allRoutes) [member function]
     cls.add_method('GetListOfAllRoutes', 
                    'void', 
                    [param('std::map< ns3::Ipv4Address, ns3::dsdv::RoutingTableEntry > &', 'allRoutes')])
-    ## dsdv-rtable.h (module 'dsdv'): void ns3::dsdv::RoutingTable::GetListOfDestinationWithNextHop(ns3::Ipv4Address nxtHp, std::map<ns3::Ipv4Address, ns3::dsdv::RoutingTableEntry, std::less<ns3::Ipv4Address>, std::allocator<std::pair<const ns3::Ipv4Address, ns3::dsdv::RoutingTableEntry> > > & dstList) [member function]
+    ## dsdv-rtable.h (module 'dsdv'): void ns3::dsdv::RoutingTable::GetListOfDestinationWithNextHop(ns3::Ipv4Address nxtHp, std::map<ns3::Ipv4Address, ns3::dsdv::RoutingTableEntry, std::less<ns3::Ipv4Address>, std::allocator<std::pair<const ns3::Ipv4Address, ns3::dsdv::RoutingTableEntry>>> & dstList) [member function]
     cls.add_method('GetListOfDestinationWithNextHop', 
                    'void', 
                    [param('ns3::Ipv4Address', 'nxtHp'), param('std::map< ns3::Ipv4Address, ns3::dsdv::RoutingTableEntry > &', 'dstList')])
@@ -7916,7 +7931,7 @@
                    'void', 
                    [param('ns3::Ptr< ns3::OutputStreamWrapper >', 'stream'), param('ns3::Time::Unit', 'unit', default_value='::ns3::Time::Unit::S')], 
                    is_const=True)
-    ## dsdv-rtable.h (module 'dsdv'): void ns3::dsdv::RoutingTable::Purge(std::map<ns3::Ipv4Address, ns3::dsdv::RoutingTableEntry, std::less<ns3::Ipv4Address>, std::allocator<std::pair<const ns3::Ipv4Address, ns3::dsdv::RoutingTableEntry> > > & removedAddresses) [member function]
+    ## dsdv-rtable.h (module 'dsdv'): void ns3::dsdv::RoutingTable::Purge(std::map<ns3::Ipv4Address, ns3::dsdv::RoutingTableEntry, std::less<ns3::Ipv4Address>, std::allocator<std::pair<const ns3::Ipv4Address, ns3::dsdv::RoutingTableEntry>>> & removedAddresses) [member function]
     cls.add_method('Purge', 
                    'void', 
                    [param('std::map< ns3::Ipv4Address, ns3::dsdv::RoutingTableEntry > &', 'removedAddresses')])
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/dsdv/CMakeLists.txt ns-3.36/src/dsdv/CMakeLists.txt
--- ns-3.35/src/dsdv/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/dsdv/CMakeLists.txt	2022-04-30 18:23:57.814733300 -0700
@@ -0,0 +1,17 @@
+build_lib(
+  LIBNAME dsdv
+  SOURCE_FILES
+    helper/dsdv-helper.cc
+    model/dsdv-packet-queue.cc
+    model/dsdv-packet.cc
+    model/dsdv-routing-protocol.cc
+    model/dsdv-rtable.cc
+  HEADER_FILES
+    helper/dsdv-helper.h
+    model/dsdv-packet-queue.h
+    model/dsdv-packet.h
+    model/dsdv-routing-protocol.h
+    model/dsdv-rtable.h
+  LIBRARIES_TO_LINK ${libinternet}
+  TEST_SOURCES test/dsdv-testcase.cc
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/dsdv/examples/CMakeLists.txt ns-3.36/src/dsdv/examples/CMakeLists.txt
--- ns-3.35/src/dsdv/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/dsdv/examples/CMakeLists.txt	2022-04-30 18:23:57.818733500 -0700
@@ -0,0 +1,9 @@
+build_lib_example(
+  NAME dsdv-manet
+  SOURCE_FILES dsdv-manet.cc
+  LIBRARIES_TO_LINK
+    ${libwifi}
+    ${libinternet}
+    ${libdsdv}
+    ${libapplications}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/dsdv/model/dsdv-routing-protocol.h ns-3.36/src/dsdv/model/dsdv-routing-protocol.h
--- ns-3.35/src/dsdv/model/dsdv-routing-protocol.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/dsdv/model/dsdv-routing-protocol.h	2022-04-30 18:23:57.818733500 -0700
@@ -217,9 +217,15 @@
    */
   void
   RecvDsdv (Ptr<Socket> socket);
-  /// Send packet
+  /**
+   * Send a packet
+   * \param route the route
+   * \param packet the packet
+   * \param header the IPv4 header
+   */
   void
-  Send (Ptr<Ipv4Route>, Ptr<const Packet>, const Ipv4Header &);
+  Send (Ptr<Ipv4Route> route, Ptr<const Packet> packet, const Ipv4Header & header);
+
   /**
    * Create loopback route for given header
    *
@@ -245,9 +251,14 @@
   /// Merge periodic updates
   void
   MergeTriggerPeriodicUpdates ();
-  /// Notify that packet is dropped for some reason
+  /**
+   * Notify that packet is dropped for some reason
+   * \param packet the dropped packet
+   * \param header the IPv4 header
+   * \param err the error number
+   */
   void
-  Drop (Ptr<const Packet>, const Ipv4Header &, Socket::SocketErrno);
+  Drop (Ptr<const Packet> packet, const Ipv4Header & header, Socket::SocketErrno err);
   /// Timer to trigger periodic updates from a node
   Timer m_periodicUpdateTimer;
   /// Timer used by the trigger updates in case of Weighted Settling Time is used
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/dsdv/model/dsdv-rtable.h ns-3.36/src/dsdv/model/dsdv-rtable.h
--- ns-3.35/src/dsdv/model/dsdv-rtable.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/dsdv/model/dsdv-rtable.h	2022-04-30 18:23:57.818733500 -0700
@@ -65,7 +65,7 @@
    * \param iface the interface
    * \param hops the number of hops
    * \param nextHop the IP address of the next hop
-   * \param lifetime the lifetime 
+   * \param lifetime the lifetime
    * \param SettlingTime the settling time
    * \param changedEntries flag for changed entries
    */
@@ -276,6 +276,7 @@
   /**
    * Print routing table entry
    * \param stream the output stream
+   * \param unit the Time unit
    */
   void
   Print (Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S) const;
@@ -393,6 +394,7 @@
   /**
    * Print routing table
    * \param stream the output stream
+   * \param unit the Time unit
    */
   void
   Print (Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S) const;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/dsr/bindings/callbacks_list.py ns-3.36/src/dsr/bindings/callbacks_list.py
--- ns-3.35/src/dsr/bindings/callbacks_list.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/dsr/bindings/callbacks_list.py	2022-04-30 18:23:57.818733500 -0700
@@ -1,25 +1,31 @@
 callback_classes = [
     ['ns3::ObjectBase *', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'const ns3::Address &', 'const ns3::Address &', 'ns3::NetDevice::PacketType', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::Socket>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['bool', 'ns3::Ptr<ns3::Socket>', 'const ns3::Address &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::Socket>', 'const ns3::Address &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::Socket>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'const ns3::Address &', 'const ns3::Address &', 'ns3::NetDevice::PacketType', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::Packet>', 'ns3::Ipv4Address', 'ns3::Ipv4Address', 'unsigned char', 'ns3::Ptr<ns3::Ipv4Route>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::Packet>', 'ns3::Ipv6Address', 'ns3::Ipv6Address', 'unsigned char', 'ns3::Ptr<ns3::Ipv6Route>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'const ns3::Ipv4Header &', 'ns3::Ptr<const ns3::Packet>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::Ptr<ns3::Ipv4>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'const ns3::Ipv4Header &', 'ns3::Ptr<const ns3::Packet>', 'ns3::Ipv4L3Protocol::DropReason', 'ns3::Ptr<ns3::Ipv4>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['unsigned long', 'unsigned short', 'unsigned short', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['unsigned long', 'const ns3::WifiTxVector &', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['bool', 'unsigned short', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['bool', 'const ns3::WifiTxVector &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::Mac48Address', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::ArpCache>', 'ns3::Ipv4Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'const ns3::WifiMacHeader &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::WifiMacDropReason', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned char', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'const ns3::WifiTxVector &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned char', 'ns3::Ptr<const ns3::WifiPsdu>', 'const ns3::WifiTxVector &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned char', 'std::unordered_map<unsigned short, ns3::Ptr<ns3::WifiPsdu>, std::hash<unsigned short>, std::equal_to<unsigned short>, std::allocator<std::pair<const unsigned short, ns3::Ptr<ns3::WifiPsdu>>>> *', 'const std::set<ns3::Mac48Address, std::less<ns3::Mac48Address>, std::allocator<ns3::Mac48Address>> *', 'unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::ArpCache>', 'ns3::Ipv4Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ipv4Address', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'const ns3::dsr::DsrOptionSRHeader &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
 ]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/dsr/CMakeLists.txt ns-3.36/src/dsr/CMakeLists.txt
--- ns-3.35/src/dsr/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/dsr/CMakeLists.txt	2022-04-30 18:23:57.818733500 -0700
@@ -0,0 +1,36 @@
+build_lib(
+  LIBNAME dsr
+  SOURCE_FILES
+    helper/dsr-helper.cc
+    helper/dsr-main-helper.cc
+    model/dsr-errorbuff.cc
+    model/dsr-fs-header.cc
+    model/dsr-gratuitous-reply-table.cc
+    model/dsr-maintain-buff.cc
+    model/dsr-network-queue.cc
+    model/dsr-option-header.cc
+    model/dsr-options.cc
+    model/dsr-passive-buff.cc
+    model/dsr-rcache.cc
+    model/dsr-routing.cc
+    model/dsr-rreq-table.cc
+    model/dsr-rsendbuff.cc
+  HEADER_FILES
+    helper/dsr-helper.h
+    helper/dsr-main-helper.h
+    model/dsr-errorbuff.h
+    model/dsr-fs-header.h
+    model/dsr-gratuitous-reply-table.h
+    model/dsr-maintain-buff.h
+    model/dsr-network-queue.h
+    model/dsr-option-header.h
+    model/dsr-options.h
+    model/dsr-passive-buff.h
+    model/dsr-rcache.h
+    model/dsr-routing.h
+    model/dsr-rreq-table.h
+    model/dsr-rsendbuff.h
+  LIBRARIES_TO_LINK ${libinternet}
+                    ${libwifi}
+  TEST_SOURCES test/dsr-test-suite.cc
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/dsr/examples/CMakeLists.txt ns-3.36/src/dsr/examples/CMakeLists.txt
--- ns-3.35/src/dsr/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/dsr/examples/CMakeLists.txt	2022-04-30 18:23:57.818733500 -0700
@@ -0,0 +1,13 @@
+build_lib_example(
+  NAME dsr
+  SOURCE_FILES dsr.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libnetwork}
+    ${libinternet}
+    ${libapplications}
+    ${libmobility}
+    ${libconfig-store}
+    ${libwifi}
+    ${libdsr}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/dsr/model/dsr-options.cc ns-3.36/src/dsr/model/dsr-options.cc
--- ns-3.35/src/dsr/model/dsr-options.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/dsr/model/dsr-options.cc	2022-04-30 18:23:57.822733400 -0700
@@ -1450,7 +1450,7 @@
   /*
    * The error serialized size
    */
-  uint32_t rerrSize;
+  [[maybe_unused]] uint32_t rerrSize;
   NS_LOG_DEBUG ("The error type value here " << (uint32_t)errorType);
   if (errorType == 1) // unreachable ip address
     {
@@ -1494,7 +1494,6 @@
       p->RemoveHeader (rerrUnsupport);
       rerrSize = rerrUnsupport.GetSerializedSize ();
 
-      NS_UNUSED (rerrSize);
       /// \todo This is for the other two error options, not supporting for now
       // uint32_t serialized = DoSendError (p, rerrUnsupport, rerrSize, ipv4Address, protocol);
       uint32_t serialized = 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/dsr/model/dsr-rcache.h ns-3.36/src/dsr/model/dsr-rcache.h
--- ns-3.35/src/dsr/model/dsr-rcache.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/dsr/model/dsr-rcache.h	2022-04-30 18:23:57.822733400 -0700
@@ -389,6 +389,9 @@
   DsrRouteCache ();
   virtual ~DsrRouteCache ();
 
+  // Delete assignment operator to avoid misuse
+  DsrRouteCache & operator = (DsrRouteCache const &) = delete;
+
   /**
    * \brief Remove the aged route cache entries when the route cache is full
    * \param rtVector the route cache to scan.
@@ -742,11 +745,6 @@
   }
 
 private:
-  /**
-   * \brief assignment operator - defined but not implemented to avoid misuse.
-   * \return
-   */
-  DsrRouteCache & operator= (DsrRouteCache const &);
   DsrRouteCacheEntry::IP_VECTOR m_vector;               ///< The route vector to save the ip addresses for intermediate nodes.
   uint32_t m_maxCacheLen;                               ///< The maximum number of packets that we allow a routing protocol to buffer.
   Time     RouteCacheTimeout;                           ///< The maximum period of time that dsr is allowed to for an unused route.
